﻿Formula_Place()

function myCreateProgressPanel(myMaximumValue, myProgressBarWidth){
	myProgressPanel = new Window('window', 'Progress');
	with(myProgressPanel){
		myProgressPanel.myProgressBar = add('progressbar', [12, 12, myProgressBarWidth, 24], 0, myMaximumValue);
	}
}

function myGetScriptPath() {
    try{
        return File(app.activeScript).parent;
    }
    catch(myError){
        return File(myError.fileName).parent;
    }
}

function GetBaseLineShift(FileName, dopBaseShift) {

	Baseline = 0;	
	
	if (FileName.search(".wmf")  != -1) {	
	
	var myString = new Array;	
	myFile = File(FileName);
	myFile.encoding = "BINARY";

	try {
	if (myFile.open('r')) {
		myString = myFile.read();
		myFile.close();
		}
	}
	catch (err)
	{
		alert("Не удалось открыть файл " + FileName, "Ошибка сценария");
		}
		
    if (myString.search("MathType") != -1) {		

        N1 = myString[128].charCodeAt(0);
        N2 = myString[129].charCodeAt(0);
		
		if (isNaN(N1)) {N1 = 0};
		if (isNaN(N2)) {N2 = 0};
        
        Baseline = N2 * 16 + Math.floor(N1 / 16);
		Baseline = Baseline - dopBaseShift;
		}
	else {
		Baseline = 0 }
	}

if (FileName.search(".eps")  != -1) {

	var myString = new String;
	myFile = File(FileName);
	
	try {
	if (myFile.open('r')) {
		myString = myFile.read();
		myFile.close(); }
		}
	catch (err)
	{
		alert("Не удалось открыть файл " + FileName, "Ошибка сценария");
		}

	
    FirstPos = myString.search("%%Baseline: ");
    
    if (FirstPos > 0) {
        FirstPos = FirstPos + 12;
        EndPos = myString.search("%%Dimensions:");
        LenPos = EndPos - FirstPos;
        Baseline = parseInt(myString.substr(FirstPos, LenPos));
	    Baseline = Baseline - dopBaseShift;
		}
	else {
		Baseline = 0 }
	}

return Baseline }

function Formula_Place()
	{
	var myDocument = app.activeDocument;
	
	var myParentFolder = myGetScriptPath()
	
	myIniFile = File(myParentFolder+"/formula-paste.ini");
	
	myPath= "/c/";
	myBLS = "0.7"
	
	try {
	if (myIniFile.open('r')) {
		myPath = myIniFile.readln();
		myBLS = myIniFile.readln();
		myIniFile.close(); }
	}
	catch (err)
	{
		myPath= "/c/";
		myBLS = "0.7"
		}

do {
	var myDialog = app.dialogs.add({name: "Вставка формул для InDesign CS4", canCancel: true});
	with(myDialog.dialogColumns.add()) {
	with (borderPanels.add()) {
		with(dialogColumns.add()) {
    	with(dialogRows.add()) {
    		staticTexts.add({staticLabel:"Задайте корректировку сдвига базовой линии: "});
 				var dopBS = textEditboxes.add({editContents: myBLS});
 			} 	
  	}
	}
  	with(dialogRows.add()) {
  		staticTexts.add({staticLabel:"\u00A9 Владислав Микизиль, 2009"});
  	} 
	}
	if (!myDialog.show()) exit();
	
		if (isNaN(dopBS.editContents)) {
		alert("Пожалуйста, введите правильно цифры. Образец - 0.7")
		}
		else {
		dopBaseShift = parseFloat(dopBS.editContents)}
}
while (isNaN(dopBS.editContents))

	var myDir = Folder.selectDialog("Выберите путь к файлам с формулами", myPath);  //"/h/work catalog/phoenix/Физика - подготовка к ЕГЭ 2009/PicsWMF"
	if (myDir ==null) {exit()};
	myDir=myDir+"/";

	try {
	if (myIniFile.open('w')) {
		myIniFile.writeln(myDir);
		myIniFile.writeln(dopBaseShift);
		myIniFile.close(); }
		}
	catch (err)
	{
		alert(err+"Не удалось записать ini-файл")
		}

    with (app.activeDocument.viewPreferences)
	{
      myOldXUnits = horizontalMeasurementUnits;
      myOldYUnits = verticalMeasurementUnits;

      horizontalMeasurementUnits = MeasurementUnits.POINTS;
      verticalMeasurementUnits = MeasurementUnits.POINTS;
    }
    
    try {
    var mySelection = myDocument.selection[0]
	switch (mySelection.constructor.name) {
		case "Text":
			alert("Выделен " + mySelection.constructor.name + ". Обрабатываем");
			var myDocument = mySelection
			break;
		case "TextStyleRange":
			alert("Выделен " + mySelection.constructor.name + ". Обрабатываем", "Вставка формул для InDesign CS4");
			var myDocument = mySelection
			break;
		case "TextFrame":
			alert("Выделен " + mySelection.constructor.name + ". Обрабатываем", "Вставка формул для InDesign CS4");
			var myDocument = mySelection
			break;
		case "Paragraph":
			alert("Выделен " + mySelection.constructor.name + ". Обрабатываем", "Вставка формул для InDesign CS4");
			var myDocument = mySelection
			break;
		}	
	}
    catch(err)
	{ alert("Ничего не выделено. Обрабатываем все", "Вставка формул для InDesign CS4") }
    
    app.findGrepPreferences = NothingEnum.nothing;
	    
    myMask = "<<Eqn\\d+.[\\l\\u]+>>"
    
    app.findGrepPreferences.findWhat = myMask
	
    var myGrep = myDocument.findGrep()
	
	myCount = myGrep.length
    
    alert ("Количество формул = " + myCount, "Вставка формул для InDesign CS4")
   
	var myIncrement = (myCount-1)/200;
	myCreateProgressPanel(200, 600);
	myProgressPanel.show();
   
    for (i = 0; i < myCount; i++) {
      
      var myTextFind = myGrep[i]

	 myProgressPanel.myProgressBar.value = i/myIncrement;
	  
      myFileName = myTextFind.contents
      
      myFileName = myFileName.substr(2, myFileName.length - 4)
      
     myFile = myDir + myFileName
	  
     myBaseLine = GetBaseLineShift(myFile, dopBaseShift)
   
    myTextFind.place (myFile)
    
    var myFormuls = myTextFind.parentStory.rectangles
    var myFormula = myFormuls.item(i)
	
    myFormula.anchoredObjectSettings.anchorYoffset = -myBaseLine

    }

   // myProgressPanel.myProgressBar.value = 0;
    myProgressPanel.hide();

    with (app.activeDocument.viewPreferences)
	{

      horizontalMeasurementUnits = myOldXUnits
      verticalMeasurementUnits = myOldYUnits

    }
    
    alert("Вставлено " + i + " формул", "Окончание работы сценария")
}
